'****************************************************************
'*  Name    : 24FJ64GA002                                       *
'*  Author  : Firewing System Generator                         *
'*  Notice  : Generated on the 2014/12/14                       *
'****************************************************************
module PIC

' system header...
#const _core = &H0018                  ' processor core
#variable _maxrom = &H0101FA           ' 64 KB of program ROM
#variable _maxram = &H2000             ' 8192 bytes of user RAM
#variable _xramstart = &H0800          ' x RAM start in bytes
#variable _xram = &H2000               ' x RAM size in bytes
#variable _yramstart = &H0000          ' y RAM start in bytes
#variable _yram = &H0000               ' y RAM size in bytes
#const _dmaramstart = &H0000           ' DMA ram start in bytes
#const _dmaram = &H0000                ' DMA RAM size in bytes
#const _eeprom = &H0000                ' 0 bytes of EEPROM
#const _ports = &H02                   ' 2 available ports
#const _usb = &H00                     ' USB is NOT supported
#const _rtcc = &H01                    ' onboard Real-Time Clock/Calendar (RTCC) available
#const _pmp = &H01                     ' onboard Parallel Master Slave Port (PMP) available
#const _dma = &H00                     ' Direct Memory Access (DMA) is NOT supported
#const _ecan = &H00                    ' Enhanced CAN is NOT supported
#const _usart = &H02                   ' 2 USART(s) available
#const _spi = &H02                     ' 2 SPI module(s) available
#const _i2c = &H02                     ' 2 I2C module(s) available
#const _pwm = &H05                     ' 5 PWM module(s) available

' special function registers...
public system WREG0 as ushort absolute &H0000
public system WREG1 as ushort absolute &H0002
public system WREG2 as ushort absolute &H0004
public system WREG3 as ushort absolute &H0006
public system WREG4 as ushort absolute &H0008
public system WREG5 as ushort absolute &H000A
public system WREG6 as ushort absolute &H000C
public system WREG7 as ushort absolute &H000E
public system WREG8 as ushort absolute &H0010
public system WREG9 as ushort absolute &H0012
public system WREG10 as ushort absolute &H0014
public system WREG11 as ushort absolute &H0016
public system WREG12 as ushort absolute &H0018
public system WREG13 as ushort absolute &H001A
public system WREG14 as ushort absolute &H001C
public system WREG15 as ushort absolute &H001E
public system SPLIM as ushort absolute &H0020
public system PCL as ushort absolute &H002E
public system PCH as ushort absolute &H0030
public system TBLPAG as ushort absolute &H0032
public system PSVPAG as ushort absolute &H0034
public system RCOUNT as ushort absolute &H0036
public system SR as ushort absolute &H0042
public system CORCON as ushort absolute &H0044
public system DISICNT as ushort absolute &H0052
public system CNEN1 as ushort absolute &H0060
public system CNEN2 as ushort absolute &H0062
public system CNPU1 as ushort absolute &H0068
public system CNPU2 as ushort absolute &H006A
public system INTCON1 as ushort absolute &H0080
public system INTCON2 as ushort absolute &H0082
public system IFS0 as ushort absolute &H0084
public system IFS1 as ushort absolute &H0086
public system IFS2 as ushort absolute &H0088
public system IFS3 as ushort absolute &H008A
public system IFS4 as ushort absolute &H008C
public system IEC0 as ushort absolute &H0094
public system IEC1 as ushort absolute &H0096
public system IEC2 as ushort absolute &H0098
public system IEC3 as ushort absolute &H009A
public system IEC4 as ushort absolute &H009C
public system IPC0 as ushort absolute &H00A4
public system IPC1 as ushort absolute &H00A6
public system IPC2 as ushort absolute &H00A8
public system IPC3 as ushort absolute &H00AA
public system IPC4 as ushort absolute &H00AC
public system IPC5 as ushort absolute &H00AE
public system IPC6 as ushort absolute &H00B0
public system IPC7 as ushort absolute &H00B2
public system IPC8 as ushort absolute &H00B4
public system IPC9 as ushort absolute &H00B6
public system IPC10 as ushort absolute &H00B8
public system IPC11 as ushort absolute &H00BA
public system IPC12 as ushort absolute &H00BC
public system IPC15 as ushort absolute &H00C2
public system IPC16 as ushort absolute &H00C4
public system IPC18 as ushort absolute &H00C8
public system TMR1 as ushort absolute &H0100
public system PR1 as ushort absolute &H0102
public system T1CON as ushort absolute &H0104
public system TMR2 as ushort absolute &H0106
public system TMR3HLD as ushort absolute &H0108
public system TMR3 as ushort absolute &H010A
public system PR2 as ushort absolute &H010C
public system PR3 as ushort absolute &H010E
public system T2CON as ushort absolute &H0110
public system T3CON as ushort absolute &H0112
public system TMR4 as ushort absolute &H0114
public system TMR5HLD as ushort absolute &H0116
public system TMR5 as ushort absolute &H0118
public system PR4 as ushort absolute &H011A
public system PR5 as ushort absolute &H011C
public system T4CON as ushort absolute &H011E
public system T5CON as ushort absolute &H0120
public system IC1BUF as ushort absolute &H0140
public system IC1CON as ushort absolute &H0142
public system IC2BUF as ushort absolute &H0144
public system IC2CON as ushort absolute &H0146
public system IC3BUF as ushort absolute &H0148
public system IC3CON as ushort absolute &H014A
public system IC4BUF as ushort absolute &H014C
public system IC4CON as ushort absolute &H014E
public system IC5BUF as ushort absolute &H0150
public system IC5CON as ushort absolute &H0152
public system OC1RS as ushort absolute &H0180
public system OC1R as ushort absolute &H0182
public system OC1CON as ushort absolute &H0184
public system OC2RS as ushort absolute &H0186
public system OC2R as ushort absolute &H0188
public system OC2CON as ushort absolute &H018A
public system OC3RS as ushort absolute &H018C
public system OC3R as ushort absolute &H018E
public system OC3CON as ushort absolute &H0190
public system OC4RS as ushort absolute &H0192
public system OC4R as ushort absolute &H0194
public system OC4CON as ushort absolute &H0196
public system OC5RS as ushort absolute &H0198
public system OC5R as ushort absolute &H019A
public system OC5CON as ushort absolute &H019C
public system I2C1RCV as ushort absolute &H0200
public system I2C1TRN as ushort absolute &H0202
public system I2C1BRG as ushort absolute &H0204
public system I2C1CON as ushort absolute &H0206
public system I2C1STAT as ushort absolute &H0208
public system I2C1ADD as ushort absolute &H020A
public system I2C1MSK as ushort absolute &H020C
public system I2C2RCV as ushort absolute &H0210
public system I2C2TRN as ushort absolute &H0212
public system I2C2BRG as ushort absolute &H0214
public system I2C2CON as ushort absolute &H0216
public system I2C2STAT as ushort absolute &H0218
public system I2C2ADD as ushort absolute &H021A
public system I2C2MSK as ushort absolute &H021C
public system U1MODE as ushort absolute &H0220
public system U1STA as ushort absolute &H0222
public system U1TXREG as ushort absolute &H0224
public system U1RXREG as ushort absolute &H0226
public system U1BRG as ushort absolute &H0228
public system U2MODE as ushort absolute &H0230
public system U2STA as ushort absolute &H0232
public system U2TXREG as ushort absolute &H0234
public system U2RXREG as ushort absolute &H0236
public system U2BRG as ushort absolute &H0238
public system SPI1STAT as ushort absolute &H0240
public system SPI1CON1 as ushort absolute &H0242
public system SPI1CON2 as ushort absolute &H0244
public system SPI1BUF as ushort absolute &H0248
public system SPI2STAT as ushort absolute &H0260
public system SPI2CON1 as ushort absolute &H0262
public system SPI2CON2 as ushort absolute &H0264
public system SPI2BUF as ushort absolute &H0268
public system TRISA as ushort absolute &H02C0
public system LATA as ushort absolute &H02C4
public system ODCA as ushort absolute &H02C6
public system TRISB as ushort absolute &H02C8
public system LATB as ushort absolute &H02CC
public system ODCB as ushort absolute &H02CE
public system PADCFG1 as ushort absolute &H02FC
public system ADC1BUF0 as ushort absolute &H0300
public system ADC1BUF1 as ushort absolute &H0302
public system ADC1BUF2 as ushort absolute &H0304
public system ADC1BUF3 as ushort absolute &H0306
public system ADC1BUF4 as ushort absolute &H0308
public system ADC1BUF5 as ushort absolute &H030A
public system ADC1BUF6 as ushort absolute &H030C
public system ADC1BUF7 as ushort absolute &H030E
public system ADC1BUF8 as ushort absolute &H0310
public system ADC1BUF9 as ushort absolute &H0312
public system ADC1BUFA as ushort absolute &H0314
public system ADC1BUFB as ushort absolute &H0316
public system ADC1BUFC as ushort absolute &H0318
public system ADC1BUFD as ushort absolute &H031A
public system ADC1BUFE as ushort absolute &H031C
public system ADC1BUFF as ushort absolute &H031E
public system AD1CON1 as ushort absolute &H0320
public system AD1CON2 as ushort absolute &H0322
public system AD1CON3 as ushort absolute &H0324
public system AD1CHS as ushort absolute &H0328
public system AD1PCFG as ushort absolute &H032C
public system AD1CSSL as ushort absolute &H0330
public system PMCON as ushort absolute &H0600
public system PMMODE as ushort absolute &H0602
public system PMADDR as ushort absolute &H0604
public system PMDOUT1 as ushort absolute &H0604
public system PMDOUT2 as ushort absolute &H0606
public system PMDIN1 as ushort absolute &H0608
public system PMDIN2 as ushort absolute &H060A
public system PMAEN as ushort absolute &H060C
public system PMSTAT as ushort absolute &H060E
public system ALRMVAL as ushort absolute &H0620
public system ALCFGRPT as ushort absolute &H0622
public system RTCVAL as ushort absolute &H0624
public system RCFGCAL as ushort absolute &H0626
public system CMCON as ushort absolute &H0630
public system CVRCON as ushort absolute &H0632
public system CRCCON as ushort absolute &H0640
public system CRCXOR as ushort absolute &H0642
public system CRCDAT as ushort absolute &H0644
public system CRCWDAT as ushort absolute &H0646
public system RPINR0 as ushort absolute &H0680
public system RPINR1 as ushort absolute &H0682
public system RPINR3 as ushort absolute &H0686
public system RPINR4 as ushort absolute &H0688
public system RPINR7 as ushort absolute &H068E
public system RPINR8 as ushort absolute &H0690
public system RPINR9 as ushort absolute &H0692
public system RPINR11 as ushort absolute &H0696
public system RPINR18 as ushort absolute &H06A4
public system RPINR19 as ushort absolute &H06A6
public system RPINR20 as ushort absolute &H06A8
public system RPINR21 as ushort absolute &H06AA
public system RPINR22 as ushort absolute &H06AC
public system RPINR23 as ushort absolute &H06AE
public system RPOR0 as ushort absolute &H06C0
public system RPOR1 as ushort absolute &H06C2
public system RPOR2 as ushort absolute &H06C4
public system RPOR3 as ushort absolute &H06C6
public system RPOR4 as ushort absolute &H06C8
public system RPOR5 as ushort absolute &H06CA
public system RPOR6 as ushort absolute &H06CC
public system RPOR7 as ushort absolute &H06CE
public system RCON as ushort absolute &H0740
public system OSCCON as ushort absolute &H0742
public system OSCCONL as ushort absolute &H0742
public system OSCCONH as ushort absolute &H0743
public system CLKDIV as ushort absolute &H0744
public system OSCTUN as ushort absolute &H0748
public system NVMCON as ushort absolute &H0760
public system NVMKEY as ushort absolute &H0766
public system PMD1 as ushort absolute &H0770
public system PMD2 as ushort absolute &H0772
public system PMD3 as ushort absolute &H0774

' system ports...
public system port PORTA as ushort absolute &H02C2
public system port PORTB as ushort absolute &H02CA

'  The following settings are available for CONFIG2:
'   Primary Oscillator Select:
'     POSCMOD_EC           EC Oscillator mode selected
'     POSCMOD_XT           XT Oscillator mode selected
'     POSCMOD_HS           HS Oscillator mode selected
'     POSCMOD_NONE         Primary oscillator disabled
'   I2C1 Pin Location Select:
'     I2C1SEL_SEC          Use alternate SCL1/SDA1 pins
'     I2C1SEL_PRI          Use default SCL1/SDA1 pins
'   IOLOCK Protection:
'     IOL1WAY_OFF          IOLOCK may be changed via unlocking seq
'     IOL1WAY_ON           Once IOLOCK is set, cannot be changed
'   Primary Oscillator Output Function:
'     OSCIOFNC_ON          OSC2/CLKO/RC15 functions as port I/O (RC15)
'     OSCIOFNC_OFF         OSC2/CLKO/RC15 functions as CLKO (FOSC/2)
'   Clock Switching and Monitor:
'     FCKSM_CSECME         Clock switching is enabled, Fail-Safe Clock Monitor is enabled
'     FCKSM_CSECMD         Clock switching is enabled, Fail-Safe Clock Monitor is disabled
'     FCKSM_CSDCMD         Clock switching and Fail-Safe Clock Monitor are disabled
'   Oscillator Select:
'     FNOSC_FRC            Fast RC Oscillator (FRC)
'     FNOSC_FRCPLL         Fast RC Oscillator with PLL module (FRCPLL)
'     FNOSC_PRI            Primary Oscillator (XT, HS, EC)
'     FNOSC_PRIPLL         Primary Oscillator with PLL module (HSPLL, ECPLL)
'     FNOSC_SOSC           Secondary Oscillator (SOSC)
'     FNOSC_LPRC           Low-Power RC Oscillator (LPRC)
'     FNOSC_FRCDIV         Fast RC Oscillator with Postscaler (FRCDIV)
'   Sec Oscillator Select:
'     SOSCSEL_LPSOSC       Low Power Secondary Oscillator (LPSOSC)
'     SOSCSEL_SOSC         Default Secondary Oscillator (SOSC)
'   Wake-up timer Select:
'     WUTSEL_FST           Fast Wake-up Timer
'     WUTSEL_LEG           Legacy Wake-up Timer
'   Internal External Switch Over Mode:
'     IESO_OFF             IESO mode (Two-Speed Start-up) disabled
'     IESO_ON              IESO mode (Two-Speed Start-up) enabled

' CONFIG2
public config CONFIG2(CONFIG2) = {_
   POSCMOD_EC, POSCMOD_XT, POSCMOD_HS, POSCMOD_NONE, I2C1SEL_SEC, I2C1SEL_PRI, IOL1WAY_OFF, IOL1WAY_ON, OSCIOFNC_ON,_
   OSCIOFNC_OFF, FCKSM_CSECME, FCKSM_CSECMD, FCKSM_CSDCMD, FNOSC_FRC, FNOSC_FRCPLL, FNOSC_PRI, FNOSC_PRIPLL,_
   FNOSC_SOSC, FNOSC_LPRC, FNOSC_FRCDIV, SOSCSEL_LPSOSC, SOSCSEL_SOSC, WUTSEL_FST, WUTSEL_LEG, IESO_OFF,_
   IESO_ON}

'  The following settings are available for CONFIG1:
'   Watchdog Timer Postscaler:
'     WDTPS_PS1            1:1
'     WDTPS_PS2            1:2
'     WDTPS_PS4            1:4
'     WDTPS_PS8            1:8
'     WDTPS_PS16           1:16
'     WDTPS_PS32           1:32
'     WDTPS_PS64           1:64
'     WDTPS_PS128          1:128
'     WDTPS_PS256          1:256
'     WDTPS_PS512          1:512
'     WDTPS_PS1024         1:1,024
'     WDTPS_PS2048         1:2,048
'     WDTPS_PS4096         1:4,096
'     WDTPS_PS8192         1:8,192
'     WDTPS_PS16384        1:16,384
'     WDTPS_PS32768        1:32,768
'   WDT Prescaler:
'     FWPSA_PR32           Prescaler ratio of 1:32
'     FWPSA_PR128          Prescaler ratio of 1:128
'   Watchdog Timer Window:
'     WINDIS_OFF           Windowed Watchdog Timer enabled; FWDTEN must be 1
'     WINDIS_ON            Standard Watchdog Timer enabled,(Windowed-mode is disabled)
'   Watchdog Timer Enable:
'     FWDTEN_OFF           Watchdog Timer is disabled
'     FWDTEN_ON            Watchdog Timer is enabled
'   Comm Channel Select:
'     ICS_PGx3             Emulator EMUC3/EMUD3 pins are shared with PGC3/PGD3
'     ICS_PGx2             Emulator EMUC2/EMUD2 pins are shared with PGC2/PGD2
'     ICS_PGx1             Emulator EMUC1/EMUD1 pins are shared with PGC1/PGD1
'   Set Clip On Emulation Mode:
'     COE_ON               Reset Into Clip On Emulation Mode
'     COE_OFF              Reset Into Operational Mode
'   Background Debug:
'     BKBUG_ON             Device resets into Debug mode
'     BKBUG_OFF            Device resets into Operational mode
'   General Code Segment Write Protect:
'     GWRP_ON              Writes to program memory are disabled
'     GWRP_OFF             Writes to program memory are allowed
'   General Code Segment Code Protect:
'     GCP_ON               Code protection is enabled for the entire program memory space
'     GCP_OFF              Code protection is disabled
'   JTAG Port Enable:
'     JTAGEN_OFF           JTAG port is disabled
'     JTAGEN_ON            JTAG port is enabled

' CONFIG1
public config CONFIG1(CONFIG1) = {_
   WDTPS_PS1, WDTPS_PS2, WDTPS_PS4, WDTPS_PS8, WDTPS_PS16, WDTPS_PS32, WDTPS_PS64, WDTPS_PS128, WDTPS_PS256,_
   WDTPS_PS512, WDTPS_PS1024, WDTPS_PS2048, WDTPS_PS4096, WDTPS_PS8192, WDTPS_PS16384, WDTPS_PS32768, FWPSA_PR32,_
   FWPSA_PR128, WINDIS_OFF, WINDIS_ON, FWDTEN_OFF, FWDTEN_ON, ICS_PGx3, ICS_PGx2, ICS_PGx1,_
   COE_ON, COE_OFF, BKBUG_ON, BKBUG_OFF, GWRP_ON, GWRP_OFF, GCP_ON, GCP_OFF,_
   JTAGEN_OFF, JTAGEN_ON}

' interrupts...
public const OscillatorFail as string = "OscillatorFail"
public const AddressError as string = "AddressError"
public const StackError as string = "StackError"
public const MathError as string = "MathError"
public const INT0Interrupt as string = "INT0Interrupt, IEC0.0"
public const IC1Interrupt as string = "IC1Interrupt, IEC0.1"
public const OC1Interrupt as string = "OC1Interrupt, IEC0.2"
public const T1Interrupt as string = "T1Interrupt, IEC0.3"
public const IC2Interrupt as string = "IC2Interrupt, IEC0.5"
public const OC2Interrupt as string = "OC2Interrupt, IEC0.6"
public const T2Interrupt as string = "T2Interrupt, IEC0.7"
public const T3Interrupt as string = "T3Interrupt, IEC0.8"
public const SPI1ErrInterrupt as string = "SPI1ErrInterrupt, IEC0.9"
public const SPI1Interrupt as string = "SPI1Interrupt, IEC0.10"
public const U1RXInterrupt as string = "U1RXInterrupt, IEC0.11"
public const U1TXInterrupt as string = "U1TXInterrupt, IEC0.12"
public const ADC1Interrupt as string = "ADC1Interrupt, IEC0.13"
public const SI2C1Interrupt as string = "SI2C1Interrupt, IEC1.0"
public const MI2C1Interrupt as string = "MI2C1Interrupt, IEC1.1"
public const CompInterrupt as string = "CompInterrupt, IEC1.2"
public const CNInterrupt as string = "CNInterrupt, IEC1.3"
public const INT1Interrupt as string = "INT1Interrupt, IEC1.4"
public const OC3Interrupt as string = "OC3Interrupt, IEC1.9"
public const OC4Interrupt as string = "OC4Interrupt, IEC1.10"
public const T4Interrupt as string = "T4Interrupt, IEC1.11"
public const T5Interrupt as string = "T5Interrupt, IEC1.12"
public const INT2Interrupt as string = "INT2Interrupt, IEC1.13"
public const U2RXInterrupt as string = "U2RXInterrupt, IEC1.14"
public const U2TXInterrupt as string = "U2TXInterrupt, IEC1.15"
public const SPI2ErrInterrupt as string = "SPI2ErrInterrupt, IEC2.0"
public const SPI2Interrupt as string = "SPI2Interrupt, IEC2.1"
public const IC3Interrupt as string = "IC3Interrupt, IEC2.5"
public const IC4Interrupt as string = "IC4Interrupt, IEC2.6"
public const IC5Interrupt as string = "IC5Interrupt, IEC2.7"
public const OC5Interrupt as string = "OC5Interrupt, IEC2.9"
public const PMPInterrupt as string = "PMPInterrupt, IEC2.13"
public const SI2C2Interrupt as string = "SI2C2Interrupt, IEC3.1"
public const MI2C2Interrupt as string = "MI2C2Interrupt, IEC3.2"
public const RTCCInterrupt as string = "RTCCInterrupt, IEC3.14"
public const U1ErrInterrupt as string = "U1ErrInterrupt, IEC4.1"
public const U2ErrInterrupt as string = "U2ErrInterrupt, IEC4.2"
public const CRCInterrupt as string = "CRCInterrupt, IEC4.3"
public const LVDInterrupt as string = "LVDInterrupt, IEC4.8"

' entry point with startup event handler...
Public Event OnStartup()
Inline Sub Main()
   AD1PCFG = &HFFFF
   RaiseEvent OnStartup()
End Sub

end module
