'   Firewing    http://www.firewing.info/
'   PIC24FJ64GA002
'   LED blik, UART and System setting test program.
'
'   2014/12: Made by audin.
'           Checked using XC16 v1.11 (Microchip 16)
'

device=24FJ64GA002
clock=32    ' PLL out is 32MHz. 16MIPS.
imports config24fj64ga002

'
' Hardware reference,
'   http://mpu.seesaa.net/article/399685477.html#toc_07
'

sub hardwareInit()
    ' UART1 pin setting 
    RPOR6.byte1   =   3 'set RP13 to TX1  24pin
    RPINR18.byte0 =  14 'set RP14 to RX1, 25pin  
    
end sub
    
sub Main()
    Dim LED1 As portb.15         ' RB15, 26pin
    dim count as ushort = 0     ' uint16_t
    
    hardwareInit()
    SetBaudrate( Baudrate.Is38400 )
   
    While True
        High(LED1)
        DelayMS(500)
        Low(LED1)
        DelayMS(500)
        Writeline("Hello! : "_
                    + str(count,5," ")_ 
                    + " , " + "0x"_
                    + hex(count,4,"0") )
        count += 1
    End While
End Sub

