'
'   Firewing    http://www.firewing.info/
'   PIC24FJ64GA002 configration and system initialization
'
'   2014/12: Made by audin
'
module config24FJ64GA002

Config CONFIG1 = {_
    JTAGEN_OFF,_
    GCP_OFF,_
    GWRP_OFF,_
    BKBUG_OFF,_
    COE_OFF,_
    ICS_PGx1,_
    FWDTEN_OFF,_
    WDTPS_PS1_
}
config CONFIG2 = {_
    IESO_OFF,_
    SOSCSEL_SOSC,_
    WUTSEL_LEG,_
    FNOSC_FRCPLL,_  ' clock setting. IRC 8Mhz x 4
	FCKSM_CSDCMD,_
	IOL1WAY_OFF,_
	I2C1SEL_PRI,_
	POSCMOD_NONE,_
	OSCIOFNC_OFF_     ' clock monitor OSCO pin
}

Sub OnStartup() Handles PIC.OnStartup
    ' initializaton code in here
    'Intenal OSC PostScaler  RCDIV=0
    CLKDIV = CLKDIV and &hf800  ' System Clock devider 1:1
End Sub

end module

